Bug 50227 - Loss of FPU state (in pthread based numerical code, etc).
Loss of FPU state (in pthread based numerical code, etc).
Status: CLOSED CURRENTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
7.1
i386 Linux
medium Severity high
: ---
: ---
Assigned To: Arjan van de Ven
Brock Organ
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2001-07-28 14:03 EDT by dtc-rhbug
Modified: 2008-08-01 12:22 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 11:39:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Example code. (2.15 KB, text/plain)
2001-07-28 14:04 EDT, dtc-rhbug
no flags Details

  None (edit)
Description dtc-rhbug 2001-07-28 14:03:38 EDT
From Bugzilla Helper:
User-Agent: Mozilla/4.77 [en] (X11; U; Linux 2.4.3-12 i686)

Description of problem:
The linux x86 kernel tries to be too clever and does not save the FPU state
after a signal but before the FPU has been touch.  The glibc pthread
timedsuspend uses a longjmp out of the resume signal handler without saving
and restoring the FPU state. The result is that the FPU state is lost.

How reproducible:
Always

Steps to Reproduce:
1.  Compile and execute the attacted example code.
2.
3.
	

Actual Results:  fpucw: 37f
sigtrap: fpstate 0x40967860
fpucw: 37b
sigtrap: fpstate (nil)
fpucw: 37f


Expected Results:  fpucw: 37f
sigtrap: fpstate 0x40967860
fpucw: 37b
sigtrap: fpstate 0x40967860
fpucw: 37b
Floating exception
Comment 1 dtc-rhbug 2001-07-28 14:04:55 EDT
Created attachment 25287 [details]
Example code.
Comment 2 Bugzilla owner 2004-09-30 11:39:05 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.